// ---------------------------------------------------------------------------

// STK500 programmer: ADC support module

// ---------------------------------------------------------------------------

#include "main.h"
#include "adc.h"

// ----------------------------- Constants: ----------------------------------

#define ADC_REF 2560 //ADC reference voltage, mV
#define ADC_RES 1023 //ADC resolution
#define R1       220 //divider upper resistor, kOhm
#define R2       100 //divider lower resistor, kOhm

// -------------------- Measure voltage at RESET pin: ------------------------

char Adc_Get(void) 
{
	ADMUX = (1 << REFS1) | (1 << REFS0) | ADC_MUX; // Ref = 2.56 V
  ADCSR = (1 << ADEN) | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0);
	ADCSR |= (1 << ADSC);       // start conversion 
	while(ADCSR & (1 << ADSC)); // wait for result
  int code = ADC;             // read ADC code
  int v = (long)code * ((long)ADC_REF * (R1 + R2) / R2) / ADC_RES ; //V in mV  
  return((char)(v / 100));
}

// ---------------------------------------------------------------------------
