// ---------------------------------------------------------------------------

// STK500 programmer: SPI support module header file

// ---------------------------------------------------------------------------

#ifndef SPI_H
#define SPI_H

// ------------------------ Function prototypes: -----------------------------

void Spi_Init(void);    // init SPI
void Spi_Enable(void);  // enable SPI
void Spi_Disable(void); // disable SPI (all lines as inputs, pullups off)
void Spi_SetSckDuration(char d); // set SCK frequency
char Spi_GetSckDuration(void);   // read SCK frequency
void Spi_SCK_Pulse(void);   // generate pulse at SCK line
void Spi_RESET_Pulse(void); // generate pulse at RESET line
char Spi_TxRx(char data);   // TX/RX data byte via SPI

// ---------------------------------------------------------------------------

#endif

// ---------------------------------------------------------------------------

