// ---------------------------------------------------------------------------

// STK500 programmer: UART module header file

// ---------------------------------------------------------------------------

#ifndef UART_H
#define UART_H

// ------------------------ Function prototypes: -----------------------------

void Uart_Init(void);        // UART init
bool Uart_Ready(void);       // check for incoming byte
char Uart_GetChar(void);     // read byte via UART  
void Uart_SendChar(char c);  // send byte via UART
void Uart_SendStr(char *s);  // send string via UART
void Uart_SendStrFlash(char __flash *s); // send string from flash via UART
void Uart_SendNewLine(void); // send "\r\n"

// ------------------------------ Macros: ------------------------------------

// macro for automatically storing string constant in program memory:

#define Uart_SendStrF(s) do\
  { static char __flash c[] = {s};\
    Uart_SendStrFlash(c); } while(0)

// ---------------------------------------------------------------------------

#endif

// ---------------------------------------------------------------------------
